<template>
  <v-row>
    <v-col class="col-sm-6 col-md-4 col-lg-3 col-12">
      <v-card class="mx-auto" max-height="395" height="395">
        <v-card-text>
          <v-date-picker
            v-model="date1"
            :events="arrayEvents"
            event-color="green lighten-1"
            @click:date="Click"
            locale="bk-th"
            full-width
          ></v-date-picker>
        </v-card-text>
      </v-card>
    </v-col>
    <v-col class="col-sm-6 col-md-4 col-lg-3 col-12">
      <v-card class="mx-auto" max-height="395" height="395">
        <v-card-title class="align-center">
          <v-col class="align-center">
            <p class="text-truncate">ค่าใช้จ่ายทั้งหมด (วันนี้)</p>
            <p>
              {{
                !this.dateChoose
                  ? new Date().toLocaleDateString('th-TH', {
                      year: 'numeric',
                      month: 'long',
                      day: '2-digit',
                    })
                  : new Date(this.dateChoose).toLocaleDateString('th-TH', {
                      year: 'numeric',
                      month: 'long',
                      day: '2-digit',
                    })
              }}
            </p>
          </v-col>
        </v-card-title>
        <v-card-text>
          <v-row class="justify-center">
            <v-col class="d-flex flex-column align-center col col-auto">
              <p class="display-3 font-weight-black text--primary my-0">
                -{{ totalAll.Daily }}
              </p>
            </v-col>
          </v-row>
          <v-row class="justify-center">
            <v-col class="d-flex flex-column">
              <p class="my-0 text-lg-right font-weight-black">บาท</p>
            </v-col>
          </v-row>
          <v-row class="justify-space-around">
            <v-col class="d-flex flex-column align-center col-auto">
              <p class="greyTint--text my-0">รายสัปดาห์</p>
              <div>
                <span class="greyBold--text font-weight-regular">
                  {{ totalAll.Weekly }}
                </span>
                <i
                  class="v-icon notranslate mt-n1 mdi mdi-circle-small theme--light success--text"
                ></i>
              </div>
            </v-col>
            <v-col class="d-flex flex-column align-center col-auto">
              <p class="greyTint--text my-0">รายเดือน</p>
              <div>
                <span class="greyBold--text font-weight-regular">
                  {{ totalAll.Monthly }}
                </span>
                <i
                  class="v-icon notranslate mt-n1 mdi mdi-circle-small theme--light warning--text"
                ></i>
              </div>
            </v-col>
            <v-col class="d-flex flex-column align-center col-auto">
              <p class="greyTint--text my-0">รายปี</p>
              <div>
                <span class="greyBold--text font-weight-regular">{{
                  totalAll.Yearly
                }}</span>
                <i
                  class="v-icon notranslate mt-n1 mdi mdi-circle-small theme--light primary--text"
                ></i>
              </div>
            </v-col>
          </v-row>
        </v-card-text>
      </v-card>
    </v-col>
    <v-col class="col-sm-6 col-md-4 col-lg-3 col-12">
      <v-card class="mx-auto" max-height="395" height="395">
        <v-card-title>
          <p class="text-truncate">
            สรุปค่าใช้จ่ายแยกตามประเภท ((Doughnut Chart)
          </p>
        </v-card-title>
        <v-card-text>
          <doughnutDaily
            :options="chartOptions"
            :height="doughnutDaily"
            :setDataDate="setDataDate"
          ></doughnutDaily>
        </v-card-text>
      </v-card>
    </v-col>
    <v-col class="col-sm-6 col-md-4 col-lg-3 col-12">
      <v-card class="mx-auto" max-height="395" height="395">
        <v-card-title>
          <p class="text-truncate">สรุปค่าใช้จ่ายแยกตามประเภท (Bar Chart)</p>
        </v-card-title>
        <v-card-text>
          <barToday
            :options="chartOptions"
            :height="todaybarheight"
            :setDataDate="setDataDate"
          ></barToday>
        </v-card-text>
      </v-card>
    </v-col>
    <v-col class="col-12">
      <v-card class="mx-auto" max-height="500" height="450">
        <v-card-title>
          <p class="text-truncate">
            สรุป % ข้อมูลค่าใช้จ่าย จำนวน {{ standDardDay }} วัน
          </p>

          <v-spacer />
          <div style="width: 300px">
            <v-subheader class="pl-0 text-center">
              จำนวนวัน (บาร์) ของกราฟ
            </v-subheader>
            <v-slider
              v-model="standDardDay"
              thumb-label="always"
              :max="max"
              :min="min"
            ></v-slider>
          </div>
        </v-card-title>
        <v-card-text>
          <barDaily
            :height="250"
            :setDataDate="setDataDate"
            :amountDay="standDardDay"
          ></barDaily>
        </v-card-text>
      </v-card>
    </v-col>
    <v-col class="col-12">
      <v-card class="mx-auto">
        <v-card-title>
          <p class="text-truncate">
            สรุปข้อมูลค่าใช้จ่าย ประจำวัน
            {{
              !this.dateChoose
                ? new Date().toLocaleDateString('th-TH', {
                    year: 'numeric',
                    month: 'long',
                    day: '2-digit',
                  })
                : new Date(this.dateChoose).toLocaleDateString('th-TH', {
                    year: 'numeric',
                    month: 'long',
                    day: '2-digit',
                  })
            }}
          </p>
        </v-card-title>
        <v-card-text>
          <tableExpenses :setDataDate="setDataDate" />
        </v-card-text>
      </v-card>
    </v-col>
  </v-row>
</template>
<script>
import axios from 'axios'
import { mapGetters, mapActions, mapState } from 'vuex'
import covertDate from '@/mixins/formateDate'
import doughnutDaily from '@/components/dashboard/daily/doughnutDaily.vue'
import barToday from '@/components/dashboard/daily/barToday.vue'
import barDaily from '@/components/dashboard/daily/barDaily.vue'
import tableExpenses from '@/components/iexpenses/api'
export default {
  mixins: [covertDate],
  components: {
    doughnutDaily,
    barToday,
    barDaily,
    tableExpenses,
  },
  data: () => ({
    totalAll: {
      Daily: 0,
      Weekly: 0,
      Monthly: 0,
      Yearly: 0,
    },
    standDardDay: 7,
    amountDay: '',
    min: 1,
    max: 15,
    allData: '',
    totalToday: 0,
    arrPrice: '',
    chartOptions: '',
    todaybarheight: 300,
    doughnutDaily: 300,
    arrayEvents: null,
    // date1: new Date().toISOString().substr(0, 10),
    dateChoose: null,
    setDataDate: null,
  }),
  async mounted() {
    // const dataObj = this.$nuxt.$store.state.expensestable.ExpensesTable
    // this.arrayEvents = dataObj.map((x) => {
    //   return new Date(x.date).toISOString().substr(0, 10)
    // })
    this.getAllData()
    this.todaySum()
    this.weeklySum()
    this.monthlySum()
    this.yearlySum()
  },
  computed: {
    date1: {
      get() {
        return this.$store.state.template.dashboardTime
      },
      set(newVal) {
        this.$store.commit(
          'SET_DASHBOARDTIME',
          new Date(newVal).toISOString().substr(0, 10)
        )
      },
    },
    ...mapState({
      getdashboardTime: (state) => state.template.dashboardTime,
      getExpensesTable: (state) => state.expensestable.ExpensesTable,
    }),
  },
  watch: {
    getdashboardTime() {
      let getDate = new Date(
        this.$nuxt.$store.state.template.dashboardTime
      ).getTime()
      this.todaySum(
        getDate,
        this.$nuxt.$store.state.expensestable.ExpensesTable
      )
      this.weeklySum(
        getDate,
        this.$nuxt.$store.state.expensestable.ExpensesTable
      )
      this.monthlySum(
        getDate,
        this.$nuxt.$store.state.expensestable.ExpensesTable
      )
      this.yearlySum(
        getDate,
        this.$nuxt.$store.state.expensestable.ExpensesTable
      )
    },
    getExpensesTable() {
      this.getAllData(this.$nuxt.$store.state.expensestable.ExpensesTable)
    },
    setDataDate(newVal, oldVal) {
      this.todaySum(this.setDataDate)
      this.weeklySum(this.setDataDate)
      this.monthlySum(this.setDataDate)
      this.yearlySum(this.setDataDate)
    },
  },
  methods: {
    async getAllData(expensestable = '') {
      if (expensestable) {
        this.arrayEvents = expensestable.map((x) => {
          return new Date(x.date).toISOString().substr(0, 10)
        })
      }
    },
    async todaySum(valTime = 0, expensestable = '') {
      if (expensestable) {
        const checkDate = valTime
        const dataDaily = this.totalTypeMulti(
          expensestable,
          checkDate,
          checkDate
        )
        this.totalAll.Daily = this.moneyFormatter(this.sumTotal(dataDaily))
      }
    },
    async weeklySum(valTime = 0, expensestable = '') {
      if (expensestable) {
        const checkDate = valTime

        const dateNow = new Date(checkDate)
        const weekNow = dateNow.getDay()
        const oneDay = 86400000

        const dayStart = dateNow.getTime() - oneDay * weekNow
        const dayEnd = dateNow.getTime() + oneDay * (6 - weekNow)

        const dataWeekly = this.totalTypeMulti(expensestable, dayStart, dayEnd)
        this.totalAll.Weekly = this.moneyFormatter(this.sumTotal(dataWeekly))
      }
    },
    async monthlySum(valTime = 0, expensestable = '') {
      if (expensestable) {
        const checkDate = valTime

        const dt = new Date(checkDate)

        const startMonth = this.startOfMonth(dt).getTime()
        const lastMonth = this.lastOfMonth(dt).getTime()

        const dataMonthly = await this.totalTypeMulti(
          expensestable,
          startMonth,
          lastMonth
        )
        this.totalAll.Monthly = this.moneyFormatter(this.sumTotal(dataMonthly))
      }
    },
    async yearlySum(valTime = 0, expensestable = '') {
      if (expensestable) {
        const checkDate = valTime

        const dt = new Date(checkDate)

        const startYear = this.startOfYear(dt).getTime()
        const lastYear = this.lastOfYear(dt).getTime()
        const dataYearly = await this.totalTypeMulti(
          expensestable,
          startYear,
          lastYear
        )
        this.totalAll.Yearly = this.moneyFormatter(this.sumTotal(dataYearly))
      }
    },
    sumTotal(objData) {
      // return objData
      let price = 0
      Object.values(objData).forEach((val) => {
        price += val.price
      })
      return price
    },
    startOfMonth(date) {
      return new Date(date.getFullYear(), date.getMonth(), 1)
    },
    lastOfMonth(date) {
      return new Date(date.getFullYear(), date.getMonth() + 1, 0)
    },
    startOfYear(date) {
      return new Date(date.getFullYear(), 0, 1)
    },
    lastOfYear(date) {
      return new Date(date.getFullYear(), 11, 31)
    },
    moneyFormatter(moneyVal) {
      let formatter = new Intl.NumberFormat('th-TH', {
        // style: 'currency',
        currency: 'THB',
      })
      return formatter.format(moneyVal)
    },
    Click(date) {
      this.dateChoose = new Date(date).getTime()
      this.setDataDate = this.dateChoose
    },
  },
}
</script>
<style scoped>
.v-card__title p {
  color: #6e6e6e;
  line-height: 1.33;
  margin: 0;
  font-size: 20px;
  font-weight: 400;
}
</style>
